/**
 * @(#)parseFile.java	0.01 09/23/1999
 * @author 	Ken Flurchick <kenf@osc.edu>
 * Date:	09/29/1999
 * Purpose:	Parse an XML file using xml4j
 *			implementation of DOM.
 * @version 0.01 Initial version.
*/
//package PSE.pse;

import com.ibm.xml.*;
import com.ibm.xml.parser.*;
import com.ibm.xml.parsers.*;
import java.io.*;
import java.util.*;
import org.w3c.dom.*;
import com.ibm.xml.framework.*;

public class parseFile {
/**
 * Constructor:	parseFile()
 * @param		None
 * @return		None
 * @throws		None
 *
 * Methods
 *<UL TYPE="square">
 *	<LI>doParse(String name)
 *		<BR>- Parse the file named by <I>name</I>
 *	<LI>makeChildrenText(Node node)
 *		<BR>- Get the node and call the next method.
 *	<LI>makeChildrenText1 (Node node, StringBuffer buffer)
 *		<BR>- Get the text of the node.
 *</UL>
*/
	Vector nVec = new Vector();
	Vector vVec = new Vector();
	static String value = null;

	public void parseFile(){
/**
 * Method: 		parseFile
 * @param		None
 * @return		None
 * @throws		None
 *
 *	Remove an existing Mapping entry.
 *  For example, the application code
 *  is removed.
*/
	}

	public int doParse(String name, String dtdFile, Hashtable hash,
			Vector sVec){
/**
 * Method: 		doParse
 * @param		String name, String dtdFile, Hashtable hash
 * @return		integers
 *				<UL TYPE="square">
 *					<LI>0 - OK
 *					<LI>1 - Missing file name
 *					<LI>2 - Parse errors
 *				</UL>
 * @throws		None
 *
 *	Parse an XML file and return the hashtable of keys and values.
*/
		String key = null, value = null;
		String hName = null;

        if (name == null || dtdFile == null) {
            System.err.println("Missing filename.");
            return(1);
        }
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
				System.out.println("Errors > zero");
                return(2);
            }
            // Document is well-formed

            Document doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
			removeWhiteSpaceNodes(r);

			NodeList nl0 = r.getChildNodes();
			buildNodes(nl0, hash, hName, sVec);
        } catch (Exception e) {
            e.printStackTrace();
        }
		// Make the hash table.
		for(int l = 0; l < nVec.size(); l++){
			hash.put(nVec.get(l), vVec.get(l));
		}
		// System.out.println("Hash Table = " + hash.toString());
		return (0);
	}

    public void removeWhiteSpaceNodes(Element parent) {
		Node nextNode = parent.getFirstChild();
        for (Node child = parent.getFirstChild();
				nextNode != null;) {
			child = nextNode;
			nextNode = child.getNextSibling();

            if (child instanceof TXText){
				if(((TXText)child).getIsIgnorableWhitespace()){
					parent.removeChild(child);
				}
            } else if(child instanceof TXElement){
				removeWhiteSpaceNodes((Element)child);
			}
		}
    }

    public void buildNodes(NodeList nl, Hashtable hsh, String hName,
    		Vector sVec){
		int inl = 0;
		int inl2 = 0;
		int l;
		boolean found = false;

		while(inl < (nl.getLength())){
			Node childNL = nl.item(inl);
			String chName = childNL.getNodeName();
			if(chName != "#text") {
				hName = chName;
			}
			String chValue = childNL.getNodeValue();
			if (childNL instanceof TXText) {
				chValue = childNL.getNodeValue();
			} else if (childNL.hasChildNodes()){
				NodeList nl2 = childNL.getChildNodes();
				buildNodes(nl2, hsh, hName, sVec);
			}
			inl++;
			if((hName != null) && (chValue != null)) {
				if(nVec.isEmpty() == true){
					nVec.addElement(hName);
					vVec.addElement(chValue);
					found = false;
				} else if(nVec.isEmpty() != true){
					for(l = 0; l < nVec.size(); l++){
						if (hName.equals(nVec.get(l))){
							found = true;
							value = (String)vVec.get(l);
							value = value + "::" + chValue;
							vVec.setElementAt(value, l);
							break;
						}
					}
					if(found == false) {
						nVec.addElement(hName);
						vVec.addElement(chValue);
						found = false;
					}
				}
			}
		}
	}
}
